using ProjectHotel.Forms;
using System.ComponentModel;
using System.Xml.Linq;
using Unity;

namespace ProjectHotel;

public partial class FormHotelForAthletes : Form
{
    private readonly IUnityContainer _container;
    public FormHotelForAthletes(IUnityContainer container)
    {
        InitializeComponent();
        _container = container ??
            throw new ArgumentNullException(nameof(container));
    }

    private void RoomsToolStripMenuItem_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FormRooms>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

    }

    private void HotelsToolStripMenuItem_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FormHotels>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void AthletesToolStripMenuItem_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FormAthletes>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void PlacingAthleteToolStripMenuItem_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FormPlacingAthletes>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void CleaningRoomToolStripMenuItem_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FormCleaningRooms>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }

    private void DirectoryReportToolStripMenuItem_Click(object sender, EventArgs e)
    {
        try
        {
            _container.Resolve<FormDirectoryReport>().ShowDialog();
        }
        catch (Exception ex)
        {
            MessageBox.Show(ex.Message, "  ",
            MessageBoxButtons.OK, MessageBoxIcon.Error);
        }
    }
}
